//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Interop.Client.ErrorHandlingTest
{
    
    
    /// <summary>
    /// Tests that errors are propagated correctly
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "test")]
    [Tecan.Sila2.SilaIdentifierAttribute("ErrorHandlingTest")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Error Handling Test")]
    public partial interface IErrorHandlingTest
    {
        
        /// <summary>
        /// A property that raises a "Test Error" on get with the error message 'SiLA2_test_error_message'
        /// </summary>
        [Tecan.Sila2.ThrowsAttribute(typeof(TestErrorException))]
        long RaiseDefinedExecutionErrorOnGet
        {
            get;
        }
        
        /// <summary>
        /// A property that raises a "Test Error" on subscribe with the error message 'SiLA2_test_error_message'
        /// </summary>
        [Tecan.Sila2.ObservableAttribute()]
        [Tecan.Sila2.ThrowsAttribute(typeof(TestErrorException))]
        long RaiseDefinedExecutionErrorOnSubscribe
        {
            get;
        }
        
        /// <summary>
        /// A property that raises an Undefined Execution Error on get with the error message 'SiLA2_test_error_message'
        /// </summary>
        long RaiseUndefinedExecutionErrorOnGet
        {
            get;
        }
        
        /// <summary>
        /// A property that raises an Undefined Execution Error on subscribe with the error message 'SiLA2_test_error_message'
        /// </summary>
        [Tecan.Sila2.ObservableAttribute()]
        long RaiseUndefinedExecutionErrorOnSubscribe
        {
            get;
        }
        
        /// <summary>
        /// A property that first sends the integer value 1 and then raises a Defined Execution Error with the error message 'SiLA2_test_error_message'
        /// </summary>
        [Tecan.Sila2.ObservableAttribute()]
        [Tecan.Sila2.ThrowsAttribute(typeof(TestErrorException))]
        long RaiseDefinedExecutionErrorAfterValueWasSent
        {
            get;
        }
        
        /// <summary>
        /// A property that first sends the integer value 1 and then raises a Undefined Execution Error with the error message 'SiLA2_test_error_message'
        /// </summary>
        [Tecan.Sila2.ObservableAttribute()]
        long RaiseUndefinedExecutionErrorAfterValueWasSent
        {
            get;
        }
        
        /// <summary>
        /// Raises the "Test Error" with the error message 'SiLA2_test_error_message'
        /// </summary>
        [Tecan.Sila2.ThrowsAttribute(typeof(TestErrorException))]
        void RaiseDefinedExecutionError();
        
        /// <summary>
        /// Raises the "Test Error" with the error message 'SiLA2_test_error_message'
        /// </summary>
        [Tecan.Sila2.ObservableAttribute()]
        [Tecan.Sila2.ThrowsAttribute(typeof(TestErrorException))]
        Tecan.Sila2.IObservableCommand RaiseDefinedExecutionErrorObservably();
        
        /// <summary>
        /// Raises an Undefined Execution Error with the error message 'SiLA2_test_error_message'
        /// </summary>
        void RaiseUndefinedExecutionError();
        
        /// <summary>
        /// Raises an Undefined Execution Error with the error message 'SiLA2_test_error_message'
        /// </summary>
        [Tecan.Sila2.ObservableAttribute()]
        Tecan.Sila2.IObservableCommand RaiseUndefinedExecutionErrorObservably();
    }
    
    /// <summary>
    /// An error exclusively used for testing purposes
    /// </summary>
    public class TestErrorException : System.Exception
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="message">The actual error message</param>
        public TestErrorException(string message) : 
                base(message)
        {
        }
    }
}
